(import prefixes)

(import simple-tests (chicken plist) (chicken base))

(define-tester
  (prefixed?)
  (gensym* 'a)
  (gensym* 'a)
  (with-prefix (% gensym*) `(1 ,%a (,%b ,%a) ,%c d))
  (let ((%a (gensym* 'a)) (%b (gensym* 'b)) (%c (gensym* 'c)))
    `(1 ,%a (,%b ,%a) ,%c d))
  (equal?
    (with-prefix (% gensym*) `(1 ,%a (,%b ,%a) ,%c d))
    (let ((%a (gensym* 'a)) (%b (gensym* 'b)) (%c (gensym* 'c)))
      `(1 ,%a (,%b a) ,%c d)))
  #f
  (equal?
    (with-prefix (% gensym*) `(1 ,%a (,%b a) ,%c d))
    (let ((%a (gensym* 'a)) (%b (gensym* 'b)) (%c (gensym* 'c)))
      `(1 ,%a (,%b ,%a) ,%c d)))
  #f)

(test-all PREFIXES
  prefixed?
  )
